力扣-盛最多水的容器

1.题目描述

2.题目链接

11. 盛最多水的容器 - 力扣(LeetCode)

3.题目解析

题目中的储水量=两边差*短边高度 。也就是说,两条边中,决定储水量的是短边的高度。

我们可以定义两个指针,一个在最左边,一个在最右边。

那么双指针的移动逻辑是什么呢?

首先 ,无论是移动左指针,还是移动右指针,只要移动指针 ,两边差就都会缩小 ,而且缩小的幅度一样(都是走一步)。

第二 ,储水量=两边差*短边高度,如果我们移动较高边的指针,会有两种情况:

1.得到的新边 curNew大于原较低边的高度 dest,那么"储水量=两边差*短边高度"的中的短边高度就没有影响:min(height【curNew】,height【dest】)还是等于height【dest】,所以储水量计算公式中的短边高度依然是原来的height【dest】。而两边差是已知缩小的,所以储水量会变小。
2.得到的新边 curNew小于原较低边的高度 dest,那么"储水量=两边差*短边高度"的中的短边高度就会变小:min(height【curNew】,height【dest】)=height【curNew】且height【curNew】<height【dest】,也就是说,这种情况下,短边高度虽然受到影响 ,变为height【curNew】,但是新的短边高度height【curNew】<原来的短边高度height【dest】。两边差和短边高度都在变小,所以"储水量=两边差*短边高度"自然也就变小了。

这里我们用到了数学中的单调性判断 ,可以得到我们要想得到更高储水量,就只能移动较低边的指针。

我们可以不断地移动较低边的指针 ,并把每一个储水量V计算出来 ,再定义一个int型整数ret=0,不断地取ret和新储水量的最大值 ,当cur=dest时,双指针相遇 ,数组遍历完毕,我们也就得到储水量的最大值。

4.解答代码

java 复制代码
class Solution {
    public int maxArea(int[] height) {
        int cur=0,dest=height.length-1,ret=0;
        while(cur<dest){
            int v=Math.min(height[cur],height[dest])*(dest-cur);
            ret=Math.max(ret,v);
            if(height[cur]<height[dest]){
                cur++;
            }
            else{
                dest--;
            }
        }
        return ret;
    }
}
相关推荐
CHEEVEN_QY3 分钟前
热仿真在液冷板设计中的应用价值与局限性客观评估
人工智能·算法
无忧.芙桃10 分钟前
图的精髓:邻接矩阵与遍历全解析
c++·算法·面试·深度优先·广度优先
Nil20813 分钟前
leetcode 1143最长公共子序列
算法·leetcode·职场和发展
脚踏实地,坚持不懈!15 分钟前
Linux 内存回收机制:水位线、kswapd 与 Direct Reclaim
linux·jvm·算法
熊猫钓鱼>_>15 分钟前
告别手工贴发票:增值税发票识别+核验,搭一条报销自动化流水线
人工智能·ai·职场和发展·自动化·大模型·llm·agent
小龙报20 分钟前
【零到全栈】从扩展名到终端实操,打通 Linux 基础
linux·ubuntu·云原生·职场和发展·创业创新·学习方法·程序员创富
Logic10124 分钟前
C语言/数据结构动态规划题解:字符串变回文的最少操作次数——最长回文子序列(LPS)
c语言·数据结构·算法·动态规划·时间复杂度·回文串·最长回文子序列
圣保罗的大教堂36 分钟前
leetcode 2778. 特殊元素平方和 简单
leetcode
UIU11444 分钟前
P1115 最大子段和
c++·算法
垆边人似月.1 小时前
华为题:零钱兑换
算法·华为